#  Copyright (C) 2001-2006 Artifex Software, Inc.
#  All Rights Reserved.
#
#  This software is provided AS-IS with no warranty, either express or
#  implied.
#
#  This software is distributed under license and may not be copied, modified
#  license.  Refer to licensing information at http://www.artifex.com/
#  or contact Artifex Software, Inc.,  7 Mt. Lassen Drive - Suite A-134,
#  San Rafael, CA  94903, U.S.A., +1(415)492-9861, for further information.
#
# $Id: amiga-aux.mak,v 1.11 2019/05/20 17:53:12 rzookol Exp $
# Partial makefile common to all Unix configurations.
# This makefile contains the build rules for the auxiliary programs such as
# echogs, and the 'platform' modules.

# Define the name of this makefile.
AMIGA_AUX_MAK=$(GLSRC)amiga-aux.mak

# whoosh: customised version of unix-aux.mak, many fixes,

# amigafeb2003: BEGIN INSERT: FROM gs8.00-gcc2.7.0 attempt insert this
# -------------------------------- Library -------------------------------- #
# feb2003 also added in obj/gp_amigafs.o below
# also added -include $(GLD)nosync : borrowed from unix-aux.mak
# 2april2003: added gdevamiga, ADDMOD page also
# 19april removed $(GLOBJ)gdevamiga.$(OBJ) 
amiga__=$(GLOBJ)gp_amiga.$(OBJ) $(GLOBJ)gp_upapr.$(OBJ) $(GLOBJ)gdevpipe.$(OBJ) $(GLOBJ)gp_getnv.$(OBJ) $(GLOBJ)gp_nsync.$(OBJ)\
 $(GLOBJ)gp_stdia.$(OBJ) $(GLOBJ)gp_unifn_amiga.$(OBJ) $(GLOBJ)gp_unix_cache.$(OBJ)
 
# ldexp.$(OBJ) frexp.$(OBJ) modf.$(OBJ)

$(GLGEN)amiga_.dev: $(amiga__) $(GLD)nosync.dev $(GLD)smd5.dev
	$(SETMOD) $(GLGEN)amiga_ $(amiga__) -include $(GLD)nosync
	$(ADDMOD) $(GLGEN)amiga_ -iodev pipe
	$(ADDMOD) $(GLGEN)amiga_ -include $(DD)page
	$(ADDMOD) $(GLGEN)amiga_ -include $(GLD)smd5
	make -C	../../libs/iconv
	make -C ../../libs/ppd 
	make -C ../../libs/z
	make -C ../../libs/png
	make -C ../../libs/jpeg6b
	make -C ../../libs/z lib/libz_shared.a
	make -C ../../libs/png lib/libpng_shared.a
	make -C ../../libs/jpeg6b lib/libjpeg_shared.a

# $(GLOBJ)gdevpipe.$(OBJ) made in lib.mak

# Amiga feb 2003: added $(arch_h) dependency as I found out!

$(GLOBJ)gp_stdia.$(OBJ): 
	$(GLCC) $(GLO_)gp_stdia.$(OBJ) $(C_) $(GLSRC)gp_stdia.c
	gcc  -g -Wl,--traditional-format  -DHAVE_STDINT_H -DIXEMUL -Iobj -Ibase $(GLO_)gp_stdia.$(OBJ)2 $(C_) $(GLSRC)gp_stdia.c

$(GLOBJ)gp_unifn_amiga.$(OBJ): 
	$(GLCC) $(GLO_)gp_unifn_amiga.$(OBJ) $(C_) $(GLSRC)gp_unifn_amiga.c
	gcc -DHAVE_STDINT_H -DIXEMUL -Iobj -Ibase $(GLO_)gp_unifn_amiga.$(OBJ)2 $(C_) $(GLSRC)gp_unifn_amiga.c

VERSION_STUFF= -DGSVERSION=\"8.50\" -DGSDATE=\"20050118\" 

$(GLOBJ)gp_amiga.$(OBJ): $(GLSRC)gp_amiga_timetravel.c $(AK) $(string__h) $(gx_h) $(gsexit_h) $(gp_h) \
  $(time__h)
	$(GLCC) -DTIME_TRAVEL $(GLO_)gp_amiga.$(OBJ) $(C_) $(GLSRC)gp_amiga_timetravel.c
	gcc  -g -Wl,--traditional-format  -DHAVE_STDINT_H -DHAVE_SYS_TIME_H -DIXEMUL -Iobj -Ibase -DTIME_TRAVEL $(GLO_)gp_amiga.$(OBJ)2 $(C_) $(GLSRC)gp_amiga_timetravel.c

# amigafeb2003 END INSERT

# amigafeb2003: removed Unix specifics 

$(GLOBJ)gp_unix_cache.$(OBJ): $(GLSRC)gp_unix_cache.c $(AK)\
 $(stdio__h) $(string__h) $(time__h) $(gconfigd_h) $(gp_h) $(md5_h)
	$(GLCC) $(GLO_)gp_unix_cache.$(OBJ) $(C_) $(GLSRC)gp_unix_cache.c

# -------------------------- Auxiliary programs --------------------------- #

$(ECHOGS_XE): $(GLSRC)echogs.c $(AK) $(stdpre_h)
	$(CCAUX) $(I_)$(GLSRCDIR)$(_I) $(O_)$(ECHOGS_XE) $(GLSRC)echogs.c

# On the RS/6000 (at least), compiling genarch.c with gcc with -O
# produces a buggy executable.
#$(GENARCH_XE): $(GLSRC)genarch.c $(AK) $(GENARCH_DEPS)
#	$(CCAUX) $(I_)$(GLSRCDIR)$(_I) $(O_)$(GENARCH_XE) $(GLSRC)genarch.c

$(GENCONF_XE): $(GLSRC)genconf.c $(AK) $(GENCONF_DEPS)
	mkdir -p obj
	$(CCAUX) $(I_)$(GLSRCDIR)$(_I) $(O_)$(GENCONF_XE) $(GLSRC)genconf.c

$(GENDEV_XE): $(GLSRC)gendev.c $(AK) $(GENDEV_DEPS)
	$(CCAUX) $(I_)$(GLSRCDIR)$(_I) $(O_)$(GENDEV_XE) $(GLSRC)gendev.c

$(GENHT_XE): $(GLSRC)genht.c $(AK) $(GENHT_DEPS)
	$(CCAUX) $(GENHT_CFLAGS) $(O_)$(GENHT_XE) $(GLSRC)genht.c

$(GENINIT_XE): $(GLSRC)geninit.c $(AK) $(GENINIT_DEPS)
	$(CCAUX) $(I_)$(GLSRCDIR)$(_I) $(O_)$(GENINIT_XE) $(GLSRC)geninit.c


MKROMFS_OBJS= $(GLOBJ)gscdefs.$(OBJ)2 $(GLOBJ)gsmisc.$(OBJ)2 \
 $(GLOBJ)gpmisc.$(OBJ)2 $(GLOBJ)gslibctx.$(OBJ)2 $(GLOBJ)gp_getnv.$(OBJ)2 \
 $(GLOBJ)gp_amiga.$(OBJ)2 $(GLOBJ)gp_unifn_amiga.$(OBJ)2 $(GLOBJ)gp_stdia.$(OBJ)2 $(GLOBJ)gsutil.$(OBJ)2

$(MKROMFS_XE): $(GLSRC)mkromfs.c $(MKROMFS_COMMON_DEPS) $(MKROMFS_OBJS)
	$(CCAUX) -g -Wl,--traditional-format -DHAVE_SYS_TIME_H  -DHAVE_STDINT_H -DIXEMUL -Iobj -Ibase  $(GENOPT)  $(I_)$(GLSRCDIR)$(_I) $(I_)$(GLOBJ)$(_I)  $(GLSRC)mkromfs.c $(O_)$(MKROMFS_XE) $(MKROMFS_OBJS) -lm  -lz

# Query the environment to construct gconfig_.h.
# The "else true;" is required because Ultrix's implementation of sh -e
# terminates execution of a command if any error occurs, even if the command
# traps the error with ||.
INCLUDE=/usr/include
$(gconfig__h): $(AMIGA_AUX_MAK) $(ECHOGS_XE)
	$(ECHOGS_XE) -w $(gconfig__h) -x 2f2a -s This file was generated automatically by unix-aux.mak. -s -x 2a2f
	sh -c "if ( test -f $(INCLUDE)/dirent.h ) then ( $(ECHOGS_XE) -a $(gconfig__h) -x 23 define HAVE_DIRENT_H) else (true) fi"
	sh -c "if ( test -f $(INCLUDE)/ndir.h ) then ( $(ECHOGS_XE) -a $(gconfig__h) -x 23 define HAVE_NDIR_H) else (true) fi"
	sh -c "if ( test -f $(INCLUDE)/sys/dir.h ) then ( $(ECHOGS_XE) -a $(gconfig__h) -x 23 define HAVE_SYS_DIR_H) else (true) fi"
	sh -c "if ( test -f $(INCLUDE)/sys/ndir.h ) then ( $(ECHOGS_XE) -a $(gconfig__h) -x 23 define HAVE_SYS_NDIR_H) else (true) fi"
	sh -c "if ( test -f $(INCLUDE)/sys/time.h ) then ( $(ECHOGS_XE) -a $(gconfig__h) -x 23 define HAVE_SYS_TIME_H) else (true) fi"
	sh -c "if ( test -f $(INCLUDE)/sys/times.h ) then ( $(ECHOGS_XE) -a $(gconfig__h) -x 23 define HAVE_SYS_TIMES_H) else (true) fi"
	sh -c "if ( test -f $(JSRCDIR)/jmemsys.h) then ( true) else ($(ECHOGS_XE) -a $(gconfig__h) -x 23 define DONT_HAVE_JMEMSYS_H) fi"

# amigafeb2003 replaced below by the above 
# if ( test -f $(INCLUDE)/dirent.h ); then $(ECHOGS_XE) -a $(gconfig__h) -x 23 define HAVE_DIRENT_H; else true; fi
# if ( test -f $(INCLUDE)/ndir.h ); then $(ECHOGS_XE) -a $(gconfig__h) -x 23 define HAVE_NDIR_H; else true; fi
# if ( test -f $(INCLUDE)/sys/dir.h ); then $(ECHOGS_XE) -a $(gconfig__h) -x 23 define HAVE_SYS_DIR_H; else true; fi
# if ( test -f $(INCLUDE)/sys/ndir.h ); then $(ECHOGS_XE) -a $(gconfig__h) -x 23 define HAVE_SYS_NDIR_H; else true; fi
# if ( test -f $(INCLUDE)/sys/time.h ); then $(ECHOGS_XE) -a $(gconfig__h) -x 23 define HAVE_SYS_TIME_H; else true; fi
# if ( test -f $(INCLUDE)/sys/times.h ); then $(ECHOGS_XE) -a $(gconfig__h) -x 23 define HAVE_SYS_TIMES_H; else true; fi
# if ( test -f $(JSRCDIR)/jmemsys.h); then true; else $(ECHOGS_XE) -a $(gconfig__h) -x 23 define DONT_HAVE_JMEMSYS_H; fi
